/*
	Downgrade Launcher R1
	by Davee
	
	Fin-rev 24/01/2011
*/

#include <pspkernel.h>
#include <pspsdk.h>
#include <psputility.h>
#include <pspctrl.h>

#include <pspsysmem_kernel.h>
#include <psploadexec_kernel.h>
#include <psploadcore.h>

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <malloc.h>

#include "utils.h"
#include "kernel_land.h"
#include "kernel_exploit.h"
#include "rebootex.h"

PSP_MODULE_INFO("6.35 downgrader", 0, 1, 1);
PSP_HEAP_SIZE_KB(3 << 10);

u8 g_pspgo_620updater_md5[] =
{
	0xAE, 0x20, 0x57, 0x5E, 0xCF, 0xF8, 0x38, 0x02, 
	0x14, 0xE8, 0xC4, 0x3E, 0xEF, 0x46, 0x6C, 0xA8,
};

u8 g_other_620updater_md5[] =
{
	0x16, 0xD8, 0xCA, 0xCC, 0x0C, 0xDB, 0x00, 0xA2, 
	0xA6, 0xA8, 0xC1, 0xB7, 0x7D, 0x7D, 0xD1, 0x36,
};

void VerifyUpdater(int model)
{
	u32 size;
	u8 *updater_md5;
	u8 md5_digest[16];
	SceKernelUtilsMd5Context md5_ctx;
	
	/* file string */
	char *file = (model == 4) ? (PSPGO_UPDATER_PATH) : (OTHER_UPDATER_PATH);
	
	/* Open file */
	SceUID fd = sceIoOpen(file, PSP_O_RDONLY, 0777);
	
	/* check for error */
	if (fd < 0)
	{
		/* error */
		return ErrorExit(5000, "Error opening %s\n", file);
	}
	
	/* get file size */
	size = sceIoLseek32(fd, 0, PSP_SEEK_END);
	sceIoLseek32(fd, 0, PSP_SEEK_SET);
	
	/* allocate memory (2 MB) */
	void *data = malloc(2 << 20);
	
	/* check for error */
	if (data == NULL)
	{
		/* error */
		sceIoClose(fd);
		return ErrorExit(5000, "Error allocating %i bytes\n", 2 << 20);
	}
	
	/* initialise MD5 */
	sceKernelUtilsMd5BlockInit(&md5_ctx);
	
	/* until no data remains */
	while (size > 0)
	{
		/* either rest of data or a buffer load */
		int read_size = (size > (2 << 20)) ? (2 << 20) : (size);
		
		/* read file */
		if (sceIoRead(fd, data, read_size) != read_size)
		{
			/* error */
			free(data);
			sceIoClose(fd);
			return;
		}
		
		/* update block */
		sceKernelUtilsMd5BlockUpdate(&md5_ctx, data, read_size);
		
		/* reduce size */
		size -= read_size;
	}
	
	/* finalise block */
	sceKernelUtilsMd5BlockResult(&md5_ctx, md5_digest);
	
	/* close file */
	sceIoClose(fd);
	
	/* free memory */
	free(data);
	
	/* determine whether PSPgo or not */
	if (model == 4)
	{
		/* set pspgo md5 digest */
		updater_md5 = g_pspgo_620updater_md5;
	}
	else
	{
		/* set other models digest */
		updater_md5 = g_other_620updater_md5;
	}
	
	/* compare the md5 */
	if (memcmp(md5_digest, updater_md5, 16) != 0)
	{
		/* error */
		ErrorExit(5000, "Error, updater MD5 mismatch!\n");
	}
}

int main(int argc, char *argv[])
{
	int res;
	SceCtrlData pad_data;
	u32 cur_buttons, prev_buttons = 0;

#ifdef HBL_SUKKIRI
	pspUtilityHtmlViewerParam html_param;
#endif
	
	/* initialise the PSP screen */
	pspDebugScreenInit();
	pspDebugScreenSetTextColor(0x00D05435);
	
	/* display welcome message */
	printf("6.35/6.31 -> 6.20 Downgrader\n" "By Davee\n\n" "Please wait... ");

#ifdef HBL_SUKKIRI	
	/* Clear html param to 0 */
	memset(&html_param, 0, sizeof(pspUtilityHtmlViewerParam));
	
	/* set enough params in html viewer to get through to module loading */
	html_param.base.size = sizeof(pspUtilityHtmlViewerParam);
	html_param.base.accessThread = 0xF;
	
	/* call sceUtilityHtmlViewerInitStart to load the htmlviewer_utility.prx which imports sceutility/scepower exploit */
	res = sceUtilityHtmlViewerInitStart(&html_param);
	
	/* check error */
	if (res < 0)
	{
		/* this could be an HBL resolving issue... */
		ErrorExit(5000, "Error 0x%08X starting htmlviewer\n", res);
	}
	
	/* wait a second for htmlviewer to get loaded */
	sceKernelDelayThread(1 * 1000 * 1000);
#endif
	
	/* do the kernel exploit */
	doKernelExploit();
	
	/* printf ok message */
	printf("OK\n");
	
	/* get the PSP model */
	int model = execKernelFunction(getModel);
	
	/* check for unsupported model */
	if (model != 0 &&			/* PSP PHAT */
		model != 1 &&			/* PSP SLIM */
		model != 2 &&			/* PSP 3000 */
		model != 3 &&			/* PSP 4000 */
		model != 4				/* PSPgo */
	)
	{
		/* unsupported */
		ErrorExit(5000, "PSP %02ig not supported.\n", model);
	}
	
	/* verify updater */
	printf("Verifying SCE Updater...");
	VerifyUpdater(model);
	printf("OK\n");
	
	/* check for pspgo */
	if (model == 4)
	{
		printf("\n" "Your PSPgo will require deletion of the [Resume Game] feature. Proceed? (X = Yes, R = No)\n");
		
		while (1)
		{
			sceCtrlPeekBufferPositive(&pad_data, 1);
			
			/* filter out previous buttons */
			cur_buttons = pad_data.Buttons & ~prev_buttons;
			prev_buttons = pad_data.Buttons;
			
			/* check for cross */
			if (cur_buttons & PSP_CTRL_CROSS)
			{
				break;
			}
			
			else if (cur_buttons & PSP_CTRL_RTRIGGER)
			{
				ErrorExit(5000, "Exiting in 5 seconds.\n");
			}
		}
		
		/* delete resume game */
		if (execKernelFunction(delete_resume_game) < 0)
		{
			/* ERROR */
			ErrorExit(5000, "Error deleting [Resume Game]. Exiting for safety reasons.\n");
		}
	}
	
	/* clear screen */
	pspDebugScreenClear();
	
	/* update should be OK, go for it */
	printf("By running this application and launching the SCE updater you accept all responsibility of any damage, temporary or permament, that may occur when using this application. This application has been tested with no loss of functionality or any damage to the system, however  it cannot be guaranteed to be completely safe." "\n" "BY RUNNING THIS APPLICATION YOU ACCEPT ALL THE RISK INVOLVED.\n\n" "Press X to start SCE updater. Press R to exit\n");
	
	while (1)
	{
		sceCtrlPeekBufferPositive(&pad_data, 1);

		/* filter out previous buttons */
		cur_buttons = pad_data.Buttons & ~prev_buttons;
		prev_buttons = pad_data.Buttons;
		
		/* check for cross */
		if (cur_buttons & PSP_CTRL_CROSS)
		{
			break;
		}
		
		else if (cur_buttons & PSP_CTRL_RTRIGGER)
		{
			ErrorExit(5000, "Exiting in 5 seconds.\n");
		}
	}
	
	/* verify updater */
	printf("Verifying SCE Updater again...");
	VerifyUpdater(model);
	printf("OK, good for launch\n");
	
	/* set the devkit */
	g_devkit_version = sceKernelDevkitVersion();
	
	/* go go go go go */
	res = execKernelFunction(launch_updater);
	
	printf("loading SCE updater failed = 0x%08X\n", res);	
	sceKernelDelayThread(5 *1000*1000);
	sceKernelExitGame();
	return 0;
}
